package $package;

import javax.jws.WebService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.ow2.weblab.core.model.Resource;
import org.ow2.weblab.core.services.AccessDeniedException;
import org.ow2.weblab.core.services.ContentNotAvailableException;
import org.ow2.weblab.core.services.InsufficientResourcesException;
import org.ow2.weblab.core.services.InvalidParameterException;
import org.ow2.weblab.core.services.ResourceContainer;
import org.ow2.weblab.core.services.ServiceNotConfiguredException;
import org.ow2.weblab.core.services.UnexpectedException;
import org.ow2.weblab.core.services.UnsupportedRequestException;
import org.ow2.weblab.core.services.resourcecontainer.LoadResourceArgs;
import org.ow2.weblab.core.services.resourcecontainer.LoadResourceReturn;
import org.ow2.weblab.core.services.resourcecontainer.SaveResourceArgs;
import org.ow2.weblab.core.services.resourcecontainer.SaveResourceReturn;

/**
 * Template for WebLab service which uses ResourceContainer interface
 * 
 * @author WebLab Team
 */
@WebService(endpointInterface = "org.ow2.weblab.core.services.ResourceContainer")
public class $className implements ResourceContainer {


	/**
	 * The instance of logger used inside $className
	 */
	private final Log logger;


	/**
	 * Constructor
	 */
	public $className() {
		this.logger = LogFactory.getLog(this.getClass());

		// TODO Initialise other fields if needed

		this.logger.info("Service $className successfully started");
	}


	@Override
	public LoadResourceReturn loadResource(final LoadResourceArgs args) throws AccessDeniedException, ContentNotAvailableException,
			InsufficientResourcesException, InvalidParameterException, ServiceNotConfiguredException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of loadResource method.");

		final String resourceId = this.checkLoadResourceArgs(args);

		this.logger.info("Load resource " + resourceId + ".");

		// TODO Implement your method here!

		this.logger.error("Method loadResource not yet implemented.");
		throw new UnsupportedRequestException("Method loadResource not yet implemented.");
	}


	/**
	 * Method that tests that the LoadResourceArgs is correct regarding
	 * specification of $className
	 * 
	 * @param args
	 *            The argument received by the loadResource method
	 * @return The resourceId inside <code>args</code>
	 * @throws InvalidParameterException
	 *             If args or the resourceId it contains is <code>null</code>
	 */
	protected String checkLoadResourceArgs(LoadResourceArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("LoadResourceArgs is null.");
		}
		final String resourceId = args.getResourceId();
		if (resourceId == null) {
			throw new InvalidParameterException("ResourceId in LoadResourceArgs is null.");
		}

		// TODO Test the existence of an usageContext if required

		return resourceId;
	}


	@Override
	public SaveResourceReturn saveResource(final SaveResourceArgs args) throws AccessDeniedException, ContentNotAvailableException,
			InsufficientResourcesException, InvalidParameterException, ServiceNotConfiguredException, UnexpectedException, UnsupportedRequestException {
		this.logger.debug("Early start of saveResource method.");

		final Resource resource = this.checkSaveResourceArgs(args);

		this.logger.info("Save resource " + resource.getUri() + ".");

		// TODO Implement your method here!

		this.logger.error("Method saveResource not yet implemented.");
		throw new UnsupportedRequestException("Method saveResource not yet implemented.", "Constructor not yet implemented.");
	}


	/**
	 * Method that tests that the SaveResourceArgs is correct regarding
	 * specification of $className
	 * 
	 * @param args
	 *            The argument received by the saveResource method
	 * @return The resource inside <code>args</code>
	 * @throws InvalidParameterException
	 *             If args or the resource it contains is <code>null</code>
	 */
	protected Resource checkSaveResourceArgs(SaveResourceArgs args) throws InvalidParameterException {
		if (args == null) {
			throw new InvalidParameterException("SaveResourceArgs is null.");
		}
		final Resource resource = args.getResource();
		if (resource == null) {
			throw new InvalidParameterException("Resource in SaveResourceArgs is null.");
		}

		// TODO Maybe implement a better test for your resource (for instance, is a Document required?)
		// TODO Test the existence of an usageContext if required

		return resource;
	}

}
